#!/bin/sh

# Take url.txt files from one tree and link them into the possibly
# pre-existing file tree and download what's not yet there.

urls=$1 # path to tree of url.txt files
shift
files=$1 # path to tree where to put files
shift

authfile=auth.txt
urlslist=urls.txt
filelist=files.txt
fileurls=file-urls.sh
mirrorlist=mirrors.list

nice_wait=$NICEWAIT
test -z "$nice_wait" && nice_wait=5

binpath=$(cd "$(dirname "$0")" && pwd)

if test -z "$urls" || test -z "$files"; then
  echo "Please give me url tree and target file tree prefixes."
  exit 1
fi

urls=$(cd "$urls" && pwd)
files=$(cd "$files" && pwd)

if test -z "$urls" || test -z "$files"; then
  echo "Absolute paths did not work out."
  exit 1
fi

cd $urls &&
find . -name "$urlslist" | while read i
do
  urlfile="$urls/$i"
  authfiler="$(dirname "$urlfile")/$authfile"
  fdir="$files/$(dirname "$i")"
  mkdir -p "$fdir"
  # Link for quick reference also for outsiders.
  ln -sf "$urlfile" "$fdir/.$urlslist"
  if test -e "$authfiler"; then
    ln -sf "$authfiler" "$fdir/.$authfile"
  fi
  ( cd "$fdir" && NICEWAIT=$nice_wait "$binpath/get-files.sh" . )
done
find . -name "$filelist" | while read i
do
  filefile="$urls/$i"
  fileurlss="$urls/$(dirname "$i")/$fileurls"
  mirrors="$urls/$(dirname "$i")/$mirrorlist"
  authfiler="$urls/$(dirname "$i")/$authfile"
  fdir="$files/$(dirname "$i")"
  mkdir -p "$fdir"
  ln -sf "$filefile"  "$fdir/.$filelist"
  ln -sf "$fileurlss" "$fdir/.$fileurls"
  if test -e "$mirrors"; then
    ln -sf "$mirrors" "$fdir/.$mirrorlist"
  fi
  if test -e "$authfiler"; then
    ln -sf "$authfiler" "$fdir/.$authfile"
  fi
  ( cd "$fdir" && NICEWAIT=$nice_wait "$binpath/get-files.sh" . )
done
